#include  "file_reader.h"
#include  "comstream.h"
#include  <fcntl.h>
#include  <iostream>
#include  <fstream>
#include  <cstdlib>
#include  <algorithm>

File_Reader::File_Reader
		( const ref_count_ptr<Abstruct_Updator> &  updator ,
		  const ref_count_ptr<Abstruct_Updator::Callback> &  callback ,
		  const std::string &  file_name )
	: file( static_cast<std::istream *>(0) ) , fd( -1 ) ,
	  updator( updator ) ,
	  valid_flag( true )
{
	if ( file_name == "-" )
	{
		this -> file = new std::istream( std::cin.rdbuf() );

		this -> fd = 0;
	}
	else if ( file_name.length() > std::strlen(".gz")
	       && file_name.substr
		  ( file_name.length() - std::strlen(".gz") ) == ".gz" )
	{
		comstream *	com = new comstream( "gzip" ,
						     "-dc" ,
						     file_name.c_str() ,
						     static_cast<char *>(0) );

		com -> close( std::ios::in );

		this -> file = com;

		if ( com -> fd( std::ios::out ) != comstream::BAD_FD )
		{
			this -> fd = com -> fd( std::ios::out );
		}
	}
	else if ( file_name.length() > std::strlen(".bz2")
	       && file_name.substr
		  ( file_name.length() - std::strlen(".bz2") ) == ".bz2" )
	{
		comstream *	com = new comstream( "bzip2" ,
						     "-dc" ,
						     file_name.c_str() ,
						     static_cast<char *>(0) );

		com -> close( std::ios::in );

		this -> file = com;

		if ( com -> fd( std::ios::out ) != comstream::BAD_FD )
		{
			this -> fd = com -> fd( std::ios::out );
		}
	}
	else if ( file_name.length() > std::strlen(".Z")
	       && file_name.substr
		  ( file_name.length() - std::strlen(".Z") ) == ".Z" )
	{
		comstream *	com = new comstream( "uncompress" ,
						     "-c" ,
						     file_name.c_str() ,
						     static_cast<char *>(0) );

		com -> close( std::ios::in );

		this -> file = com;

		if ( com -> fd( std::ios::out ) != comstream::BAD_FD )
		{
			this -> fd = com -> fd( std::ios::out );
		}
	}
	else
	{
#if 0
		std::ifstream *	file_stream = new std::ifstream
						  ( file_name.c_str() );

		this -> file = file_stream;

		if ( file_stream -> rdbuf() )
		{
			// XXX: not ANSI standard
			this -> fd = file_stream -> rdbuf() -> fd();
		}
#else
		// XXX
		comstream *	com = new comstream( "/bin/cat" ,
						     file_name.c_str() ,
						     static_cast<char *>(0) );

		com -> close( std::ios::in );

		this -> file = com;

		if ( com -> fd( std::ios::out ) != comstream::BAD_FD )
		{
			this -> fd = com -> fd( std::ios::out );
		}
#endif
	}


	if ( this -> fd >= 0 )
	{
		// close on exec
		if ( ::fcntl( this -> fd , F_SETFD , 1 ) == -1 )
		{
			std::perror( "fcntl" );
		}
	}


	if ( ! *(this -> file) )
	{
		this -> valid_flag = false;
	}


	if ( fd >= 0 )
	{
		updator -> set_fd_callback( callback , fd );
	}
}

File_Reader::~File_Reader()
{
}


std::istream &  File_Reader::input_stream() const
{
	return( *file );
}

bool   File_Reader::valid() const
{
	return( this -> valid_flag );
}

bool   File_Reader::eof() const
{
	bool	ret_eof = (this -> file -> eof() || ! *(this -> file) );

	if ( ret_eof )
	{
		updator -> stop();
	}

	return( ret_eof );
}
